/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2002-2008 by Y.D.K Co.,Ltd
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */

/*
 *  ꥢI/OǥХSIO˥ɥ饤СXPS UART Liteѡ
 */

#include <kernel.h>
#include <t_syslog.h>
#include "microblaze.h"
#include "target_serial.h"
#include "target_syssvc.h"

/*
 *  ꥢI/OݡȽ֥å
 */
typedef struct sio_port_initialization_block 
{
	void*    rx;
	void*    tx;
	void*    stat;
	void*    ctrl;
	uint32_t intno;
}
SIOPINIB;

/*
 *  ꥢI/Oݡȴ֥å
 */
struct sio_port_control_block 
{
	const SIOPINIB  *p_siopinib;  /* ꥢI/OݡȽ֥å */
	intptr_t        exinf;        /* ĥ */
	bool_t    openflag;             /* ץѤߥե饰 */
	bool_t    sendflag;             /* ߥ֥͡ե饰 */
	bool_t    getready;             /* ʸ */
	bool_t    putready;             /* ʸǤ */
};

/*
 * ꥢI/OݡȽ֥å
 */
const SIOPINIB siopinib_table[TNUM_PORT] = {
	{
		(void*)(XUARTL_PORT1_BASE + XUARTL_RX_OFFSET),
		(void*)(XUARTL_PORT1_BASE + XUARTL_TX_OFFSET),
		(void*)(XUARTL_PORT1_BASE + XUARTL_STAT_OFFSET),
		(void*)(XUARTL_PORT1_BASE + XUARTL_CTRL_OFFSET),
		(uint32_t)INTNO_SIO_PORT1
	},
#if TNUM_PORT >= 2
	{
		(void*)(XUARTL_PORT2_BASE + XUARTL_RX_OFFSET),
		(void*)(XUARTL_PORT2_BASE + XUARTL_TX_OFFSET),
		(void*)(XUARTL_PORT2_BASE + XUARTL_STAT_OFFSET),
		(void*)(XUARTL_PORT2_BASE + XUARTL_CTRL_OFFSET),
		(uint32_t)INTNO_SIO_PORT2
	},
#endif /* TNUM_PORT >= 2 */
#if TNUM_PORT >= 3
	{
		(void*)(XUARTL_PORT3_BASE + XUARTL_RX_OFFSET),
		(void*)(XUARTL_PORT3_BASE + XUARTL_TX_OFFSET),
		(void*)(XUARTL_PORT3_BASE + XUARTL_STAT_OFFSET),
		(void*)(XUARTL_PORT3_BASE + XUARTL_CTRL_OFFSET),
		(uint32_t)INTNO_SIO_PORT3
	},
#endif /* TNUM_PORT >= 3 */
};

/*
 *  ꥢI/Oݡȴ֥åΥꥢ
 */
SIOPCB	siopcb_table[TNUM_PORT];

/*
 *  ꥢI/OݡID֥åФΥޥ
 */
#define INDEX_SIOP(siopid)  ((uint_t)((siopid) - 1))
#define get_siopcb(siopid)  (&(siopcb_table[INDEX_SIOP(siopid)]))

/*
 * ʸ?
 */ 
Inline bool_t
uart_getready(SIOPCB *p_siopcb)
{
	return((sil_rew_mem((void*)(p_siopcb->p_siopinib->stat)) &
			XUARTL_STAT_RX_VALID_DATA_BIT) != 0);
}

/*
 * ʸǤ뤫?
 */
Inline bool_t
uart_putready(SIOPCB *p_siopcb)
{
	return((sil_rew_mem((void*)(p_siopcb->p_siopinib->stat)) & XUARTL_STAT_TX_FULL_BIT) == 0);
}

/*
 *  ʸμФ
 */
Inline uint8_t
uart_getchar(SIOPCB *p_siopcb)
{
	return((uint8_t)sil_rew_mem((void*)(p_siopcb->p_siopinib->rx)));
}

/*
 *  ʸν񤭹
 */
Inline void
uart_putchar(SIOPCB *p_siopcb, uint8_t c)
{
	sil_wrw_mem((void*)(p_siopcb->p_siopinib->tx), c);
}

/*
 * ؿ
 * UART Lite ˤߤ̤˶ػߵĤ뵡ǽϤʤ
 * Τᡤλˤɬ1ߤ  
 */
/*
 *  ߵ
 */
Inline void
uart_enable_send(SIOPCB *p_siopcb)
{

}

/*
 *  ߶ػ
 */
Inline void
uart_disable_send(SIOPCB *p_siopcb)
{

}


/*
 *  ߵ
 */
Inline void
uart_enable_rcv(SIOPCB *p_siopcb)
{
	sil_wrw_mem((void*)(p_siopcb->p_siopinib->ctrl), XUARTL_CTRL_ENABLE_INTR_BIT);
}

/*
 *  ߶ػ
 */
Inline void
uart_disable_rcv(SIOPCB *p_siopcb)
{
	sil_wrw_mem((void*)(p_siopcb->p_siopinib->ctrl), 0U);
}


/*
 *  SIOɥ饤Фν
 */
void
sio_initialize(intptr_t exinf)
{
	SIOPCB  *p_siopcb;
	uint_t  i;

	/*
	 *  ꥢI/Oݡȴ֥åν
	 */
	for (p_siopcb = siopcb_table, i = 0; i < TNUM_PORT; p_siopcb++, i++) {
		p_siopcb->p_siopinib = &(siopinib_table[i]);
		p_siopcb->openflag = false;
		p_siopcb->sendflag = false;
	}
}

/*
 * ꥢI/OݡȤΥץ
 */
SIOPCB *
xps_uartl_opn_por(SIOPCB *p_siopcb, intptr_t exinf)
{
	const SIOPINIB  *p_siopinib;
	p_siopinib = p_siopcb->p_siopinib;

	/*
	 *  ʸΤԤ
	 */
	while((sil_rew_mem((void*)(p_siopcb->p_siopinib->stat)) & XUARTL_STAT_TX_EMPTY_BIT) != XUARTL_STAT_TX_EMPTY_BIT);

	/*
	 *  Хåեꥢ
	 */
	sil_wrw_mem((void*)(p_siopcb->p_siopinib->ctrl),
				(XUARTL_CTRL_RST_RX_FIFO_BIT | XUARTL_CTRL_RST_TX_FIFO_BIT));

	p_siopcb->exinf = exinf;
	p_siopcb->getready = p_siopcb->putready = false;
	p_siopcb->openflag = true;

	return(p_siopcb);
}

/*
 *  ꥢI/OݡȤΥץ
 */
SIOPCB *
sio_opn_por(ID siopid, intptr_t exinf)
{
	SIOPCB  *p_siopcb = get_siopcb(siopid);
	bool_t    opnflg;
	ER      ercd;

	/*
	 *  ץ󤷤ݡȤ뤫opnflgɤǤ
	 */
	opnflg = p_siopcb->openflag;

	/*
	 *  ǥХ¸Υץ
	 */
	xps_uartl_opn_por(p_siopcb, exinf);

	/*
	 *  ꥢI/OߤΥޥ롥
	 */
	if (!opnflg) {
		ercd = ena_int(p_siopcb->p_siopinib->intno);
		assert(ercd == E_OK);
	}
	return(p_siopcb);
}

/*
 *  ꥢI/OݡȤΥ
 */
void
sio_cls_por(SIOPCB *p_siopcb)
{
	const SIOPINIB  *p_siopinib;

	p_siopinib = p_siopcb->p_siopinib;
	/* ߤζػ */
	sil_wrw_mem((void*)(p_siopcb->p_siopinib->ctrl), 0U);
	p_siopcb->openflag = false;
    
	/*
	 *  ꥢI/Oߤޥ롥
	 */
	dis_int(p_siopcb->p_siopinib->intno);    
}

/*
 *  SIOγߥϥɥ
 */
void
sio_isr(ID siopid)
{
	SIOPCB *p_siopcb = get_siopcb(siopid);

	if (uart_getready(p_siopcb)) {
		/*
		 *  ΥХå롼ƤӽФ
		 */
		sio_irdy_rcv(p_siopcb->exinf);
	}
	if (uart_putready(p_siopcb)) {
		/*
		 *  ǽХå롼ƤӽФ
		 */
		sio_irdy_snd(p_siopcb->exinf);
	}    
}

/*
 *  ꥢI/OݡȤؤʸ
 */
bool_t
sio_snd_chr(SIOPCB *siopcb, char_t c)
{
	if (uart_putready(siopcb)) {
		uart_putchar(siopcb, c);
		return(true);
	}
	return(false);
}

/*
 *  ꥢI/OݡȤʸ
 */
int_t
sio_rcv_chr(SIOPCB *siopcb)
{
	if (uart_getready(siopcb)) {
		return((int_t)(uint8_t) uart_getchar(siopcb));
	}
	return(false);
}

/*
 *  ꥢI/OݡȤΥХåε
 */
void
sio_ena_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
	switch (cbrtn) {
	  case SIO_RDY_SND:
		uart_enable_send(siopcb);
		break;
	  case SIO_RDY_RCV:
		uart_enable_rcv(siopcb);
		break;
	}
}

/*
 *  ꥢI/OݡȤΥХåζػ
 */
void
sio_dis_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
	switch (cbrtn) {
	  case SIO_RDY_SND:
		uart_disable_send(siopcb);
		break;
	  case SIO_RDY_RCV:
		uart_disable_rcv(siopcb);
		break;
	}
}
